package com.zhiqiyun.open.mapper;

import com.zhiqiyun.open.models.RoleInfo;
import com.zhiqiyun.open.mybatis.paginator.domain.PageBounds;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @author jtoms
 */
@Mapper
public interface RoleInfoMapper {

    /**
     * 插入角色信息
     *
     * @param roleInfo
     */
    void insert(RoleInfo roleInfo);

    /**
     * 更新角色信息
     *
     * @param roleInfo
     */
    void updateById(RoleInfo roleInfo);

    /**
     * 删除角色下的权限值
     *
     * @param roleIds
     */
    void deleteAuthorities(@Param("roleIds") List<Long> roleIds);

    /**
     * 查询角色的权限值
     *
     * @param roleId
     * @return
     */
    List<Long> findAuthorities(@Param("roleId") Long roleId);

    /**
     * 查询用户的权限值
     *
     * @param roleId
     * @param authorities
     */
    void insertAuthority(@Param("roleId") Long roleId, @Param("authorities") Long[] authorities);

    /**
     * 批量删除角色信息
     *
     * @param roleIds
     */
    void deleteBatchIds(@Param("roleIds") List<Long> roleIds);

    /**
     * 分页查询角色列表
     *
     * @param toQueryWrapper
     * @return
     */
    List<RoleInfo> findPage(PageBounds bounds, Map<String, Object> toQueryWrapper);
}
